#include "Calculator.h"
#include "TerminalExpression.h"
#include "AddExpression.h"
#include "SubtractExpression.h"
#include "MultiplyExpression.h"

Calculator::Calculator(Context *c) {
	this->context = c;
	this->total = 0;
}

void Calculator::visitTerminal(TerminalExpression *te) {
	total = te->evaluate(context);
}

void Calculator::visitAdd(AddExpression *ae) {
	int result;
	ae->getLeftNode()->accept(this);
	result = total;
	ae->getRightNode()->accept(this);
	result += total;
	total = result;
}

void Calculator::visitSubtract(SubtractExpression *se) {
	int result;
	se->getLeftNode()->accept(this);
	result = total;
	se->getRightNode()->accept(this);
	result -= total;
	total = result;
}

void Calculator::visitMultiply(MultiplyExpression *me) {
	int result;
	me->getLeftNode()->accept(this);
	result = total;
	me->getRightNode()->accept(this);
	result *= total;
	total = result;
}

int Calculator::getTotal() {
	return total;
}
